'---------------------------------------------------------------------------------------------------------
' SMTAssistantReport.BAS
'	Modified Pick and Place Report for use with SMT Assistant
'   We use an attribute called "PART NUMBER" to distinguih parts
'	This attriute is mapped to the Value in SMT Assistant
'   We exclude parts that have PART NUMBER = "N/A" which we assign to parts like mounting holes and fiducials
'   Other users may want to change "PART NUMBER" to "VALUE" or any other attribute
'
' By: Daraius 02 Jul 2012, TenX Precision Austin TX
'
'
'	Based on Sample 17: Excel Part List Report.BAS
'		This script has been generated by PowerPCB's VB Script Wizard on 8/23/2007 3:19:25 PM
'		It will create reports in Microsoft Excel Format.
'		You can use the following code as a skeleton for your own VB scripts
'---------------------------------------------------------------------------------------------------------


'Array of column names. You can modify it to rename columns
Const Columns = Array("RefDes", "PartNumber", "Layer", "X", "Y", "Orient", "PartDecal", "Pins", "SMD")

Sub Main

	tempFile = DefaultFilePath & "\temp.txt"
	Open tempFile For Output As #1

	'Output table header
	For i = 0 to UBound(Columns)
		OutCell Columns(i)
	Next
	Print #1
	'Output table rows
	For Each part In ActiveDocument.Components
		Set attrs = part.Attributes
		If attrs.Item("PART NUMBER") <> "N/A" Then
			OutCell part.Name
			OutCell attrs.Item("PART NUMBER")
			OutCell ActiveDocument.LayerName(part.layer)
			OutCell Format(part.PositionX, "0.000")
			OutCell Format(part.PositionY, "0.000")
			OutCell part.Orientation
			
			OutCell part.Decal
			OutCell part.Pins.Count
			OutCell Format(part.IsSMD, "Yes/No")
			'OutCell Format(part.Glued, "Yes/No")
			Print #1
		End If
	Next part

	Close #1
	ExportToExcel
End Sub

Sub ExportToExcel
	FillClipboard
	Dim xl As Object
	On Error Resume Next
	Set xl =  GetObject(,"Excel.Application")
	On Error GoTo ExcelError	' Enable error trapping.
	If xl Is Nothing Then
		Set xl =  CreateObject("Excel.Application")
	End If
	xl.Visible = True
	xl.Workbooks.Add
	xl.Range("A:C").NumberFormat = "@"
	xl.Range("D1:J1").NumberFormat = "@"
	xl.ActiveSheet.Paste
	xl.Range("A1:J1").Font.Bold = True
	xl.Range("A1:J1").NumberFormat = "@"
	xl.ActiveSheet.UsedRange.Columns.AutoFit
	xl.Range("A1").Select
	On Error GoTo 0 ' Disable error trapping. 
	Exit Sub    

ExcelError:
	MsgBox Err.Description, vbExclamation, "Error Running Excel"
	On Error GoTo 0 ' Disable error trapping.    
	Exit Sub
End Sub

Sub OutCell (txt As String)
	Print #1, txt; vbTab;
End Sub

Sub FillClipboard
	' Load whole file to string variable    
	tempFile = DefaultFilePath & "\temp.txt"
	Open tempFile  For Input As #1
	L = LOF(1)
	AllData$ = Input$(L,1)
	Close #1
	'Copy whole data to clipboard
	Clipboard AllData$ 
	Kill tempFile
End Sub
